/*
 * @(#)CodeFace.java	1.1 97/03/24
 *
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

import java.awt.*; 
import java.awt.image.*;
import java.util.*;
import java.net.URL;
import java.io.IOException;

/**
 * This is a simple applet which displays several titled images,
 * driven by a configuration file "CodeFace.dir".
 * The two lines to note are those which use methods of the
 * class object for CodeFace, <code>CodeFace.class</code>.
 * One retrieves a bytestream on the configuration file,
 * while the other one obtains the URL of each image.
 */

public class CodeFace extends java.applet.Applet {
  Properties dir = new Properties();
  Image faces[];
  String names[];

  public CodeFace() throws IOException {
    dir.load(CodeFace.class
	     .getResourceAsStream("CodeFace.dir"));
    faces = new Image[dir.size()];
    names = new String[dir.size()];
    int i = 0;
    for (Enumeration e = dir.keys(); e.hasMoreElements(); i++) {
      String file = (String) e.nextElement();
      names[i] = dir.getProperty(file);
      URL url = CodeFace.class.getResource(file);
      faces[i] = createImage((ImageProducer) url.getContent());
    }
  }

  public void paint(Graphics g) {
    int x = 0, y = 0;
    for (int i = 0; i < faces.length; i++) {
      g.drawImage(faces[i], x, y, this);
      g.drawString(names[i], x, y + faces[i].getHeight(this) + 20);
      x += faces[i].getWidth(this);
    }
  }

  public static void main(String[] args) throws IOException {
    Frame f = new Frame("CodeFace");
    f.add(new CodeFace());
    f.setSize(350, 170);
    f.show();
  }
}
